override_camera_modes = {
    [CAMERA_MODE_RADIAL]            = true,
    [CAMERA_MODE_OUTWARD_RADIAL]    = true,
    [CAMERA_MODE_CLOSE]             = true,
    [CAMERA_MODE_SLIDE_HOOT]        = true,
    [CAMERA_MODE_PARALLEL_TRACKING] = true,
    [CAMERA_MODE_FIXED]             = true,
    [CAMERA_MODE_FREE_ROAM]         = true,
    [CAMERA_MODE_SPIRAL_STAIRS]     = true,
    [CAMERA_MODE_8_DIRECTIONS]      = true
}

camera_set_use_course_specific_settings(false)

---@param m MarioState
function override_camera(m)
    if m.playerIndex ~= 0 then return end

    if override_camera_modes[m.area.camera.mode] == nil then
        return
    end

    set_camera_mode(m.area.camera, CAMERA_MODE_ROM_HACK, 0)
end

---@param camera Camera
---@param mode number
---@param frames number
---@return boolean
local function on_set_camera_mode(camera, mode, frames)
    if mode == CAMERA_MODE_ROM_HACK then return true end

    if override_camera_modes[mode] then
        set_camera_mode(camera, CAMERA_MODE_ROM_HACK, 0)
    end
end

hook_event(HOOK_ON_SET_CAMERA_MODE, on_set_camera_mode)
hook_event(HOOK_MARIO_UPDATE, override_camera)

rom_hack_cam_set_collisions(0)